/////////////////////////////////////////////////////////////////////////////
// CComm implementation
//
// $Header: /aplinksw32/comm.cpp 1     96/09/15 0:35 Akagawa $
static char *SourceFileRevision = "$Header: /aplinksw32/comm.cpp 1     96/09/15 0:35 Akagawa $";

#include "comm.h"

HANDLE	g_idComDev;
BOOL	g_signal;

CComm::CComm()
{
	m_fConnected	 = FALSE;
	m_dwBufferInData = 0;
	m_pbBuffer       = new unsigned char [RXQUEUE];
	m_dwLastError    = 0;
	g_signal		 = FALSE;
}

CComm::~CComm()
{
	if (m_fConnected)
		CloseConnection();
	delete m_pbBuffer;
}

//
// ڑ
//
BOOL CComm::OpenConnection(BYTE bPort, DWORD dwBaudRate, BYTE bByteSize, BYTE bStopBits, BYTE bParity, BYTE bFlowCtrl)
{
	char	szPort[ 15 ];
	BOOL	fRetVal;
	COMMTIMEOUTS  CommTimeOuts ;

	m_idComDev	 = 0;
	m_bPort		 = bPort;
	m_dwBaudRate = dwBaudRate;
	m_bByteSize	 = bByteSize;
	m_bStopBits	 = bStopBits;
	m_bParity	 = bParity;
	m_bFlowCtrl	 = bFlowCtrl;

	if( m_fConnected == TRUE )
		return FALSE;

	memset( &m_osRead, 0, sizeof( OVERLAPPED ) );
	memset( &m_osWrite, 0, sizeof( OVERLAPPED ) );

	// overlapped read pCxg쐬
	m_osRead.hEvent = CreateEvent(	NULL, TRUE,	FALSE, NULL ) ;
	if ( m_osRead.hEvent == NULL )
	{
		return ( FALSE );
	}

	// overlapped write pCxg쐬
	m_osWrite.hEvent = CreateEvent(	NULL, TRUE, FALSE, NULL ) ;
	if (m_osWrite.hEvent == NULL)
	{
		CloseHandle( m_osRead.hEvent );
		return ( FALSE );
	}

	wsprintf( szPort, "COM%d" , m_bPort ) ;

	// COMM foCXI[v
	if ((m_idComDev =
		CreateFile( szPort, GENERIC_READ | GENERIC_WRITE,
					0,
					NULL,
					OPEN_EXISTING,
					FILE_FLAG_OVERLAPPED, // overlapped I/O
					NULL )) == (HANDLE) -1 )
		return ( FALSE );

	// Mʒmݒ(for WaitCommEvent)
	SetCommMask( m_idComDev, EV_RXCHAR );

	// obt@ݒ
	SetupComm( m_idComDev, RXQUEUE, TXQUEUE );

	PurgeComm( m_idComDev, PURGE_TXABORT | PURGE_RXABORT |
								PURGE_TXCLEAR | PURGE_RXCLEAR );

	// ^CAEg̐ݒ@(݃^CAEgȂ^ǂݍ݃f[^҂Ȃ)
	CommTimeOuts.ReadIntervalTimeout         = MAXDWORD;
	CommTimeOuts.ReadTotalTimeoutMultiplier  = 0;
	CommTimeOuts.ReadTotalTimeoutConstant    = 0;
	CommTimeOuts.WriteTotalTimeoutMultiplier = 0;
	CommTimeOuts.WriteTotalTimeoutConstant   = 0;
	SetCommTimeouts( m_idComDev, &CommTimeOuts );

	g_idComDev = m_idComDev;
	
	//VOinhݒ
	SetConsoleCtrlHandler( NULL, FALSE );
	SetConsoleCtrlHandler( handler_routine, TRUE );

	// ʐMp[^ݒ
	fRetVal = SetupConnection( m_dwBaudRate, m_bByteSize, m_bStopBits, m_bParity, m_bFlowCtrl );

	if ( fRetVal )
	{
		m_fConnected = TRUE;
		// DTR On
		EscapeCommFunction( m_idComDev, SETDTR );
	}
	else
	{
		m_fConnected = FALSE;
		CloseHandle( m_osRead.hEvent );
		CloseHandle( m_osWrite.hEvent );
		CloseHandle( m_idComDev );
	}

	return ( fRetVal );
}

//
// COM|[g̃p[^ݒ
//
BOOL CComm::SetupConnection(DWORD dwBaudRate, BYTE bByteSize, BYTE bStopBits, BYTE bParity, BYTE bFlowCtrl)
{
	BOOL	fRetVal ;
	BYTE	bSet ;
	DCB		dcb ;

	m_dwBaudRate = dwBaudRate;
	if(bByteSize != 255)
		m_bByteSize = bByteSize;
	if(bStopBits != 255)
		m_bStopBits = bStopBits;
	if(bParity != 255)
		m_bParity = bParity;
	if(bFlowCtrl != 255)
		m_bFlowCtrl = bFlowCtrl;

	dcb.DCBlength = sizeof( DCB );

	GetCommState( m_idComDev, &dcb );

	dcb.BaudRate = m_dwBaudRate;
	dcb.ByteSize = m_bByteSize;
	dcb.Parity	 = m_bParity;
	dcb.StopBits = m_bStopBits;

	// n[ht[ݒ
	bSet = (BYTE) ((m_bFlowCtrl & FC_DTRDSR) != 0) ;
	dcb.fOutxDsrFlow = bSet ;
	if (bSet)
		dcb.fDtrControl = DTR_CONTROL_HANDSHAKE ;
	else
		dcb.fDtrControl = DTR_CONTROL_ENABLE ;

	bSet = (BYTE) ((m_bFlowCtrl & FC_RTSCTS) != 0) ;
	dcb.fOutxCtsFlow = bSet ;
	if (bSet)
		dcb.fRtsControl = RTS_CONTROL_HANDSHAKE ;
	else
		dcb.fRtsControl = RTS_CONTROL_ENABLE ;

	// \tgt[ݒ
//	bSet = (BYTE) ((m_bFlowCtrl & FC_XONXOFF) != 0) ;

	dcb.fInX =  (BYTE) ((m_bFlowCtrl & FC_RXONXOFF) != 0) ;
	dcb.fOutX = (BYTE) ((m_bFlowCtrl & FC_SXONXOFF) != 0) ;
	dcb.XonChar = ASCII_XON ;
	dcb.XoffChar = ASCII_XOFF ;
	dcb.XonLim = 100 ;
	dcb.XoffLim = 100 ;

	// ̑ݒ
	dcb.fBinary = TRUE ;
	dcb.fErrorChar = FALSE ;
	dcb.fNull      = FALSE ;
	dcb.fDsrSensitivity	= FALSE ;
	dcb.fParity = TRUE ;

	fRetVal = SetCommState( m_idComDev, &dcb ) ;

	return ( fRetVal ) ;
}

//
//ؒf
//
BOOL CComm::CloseConnection()
{
	//ڑtO Off
	m_fConnected = FALSE;

	// DTR Off
	EscapeCommFunction( m_idComDev, CLRDTR );

	// Mobt@f[^̃p[W
	PurgeComm( m_idComDev,  PURGE_RXCLEAR );

	//nh̃N[Y
	CloseHandle( m_idComDev );
	CloseHandle( m_osRead.hEvent );
	CloseHandle( m_osWrite.hEvent );
	m_idComDev = 0;

	return ( TRUE );
}

//
// PoCgM
//
int CComm::ReadCommByte()
{
	unsigned char  cChar;

	if( g_signal == TRUE )
		return ( -1 );

	if( m_dwBufferInData == 0 )				//obt@ɂ邩H
	{
		while( 1 )
		{
			if( ReadCommBlock() == FALSE )	//obt@ɓǂ߂邾M
				return -1;
			if( m_dwBufferInData > 0 )		//f[^甲o
				break;
		}
	}
	cChar = *m_pbBuffer;					//obt@PoCgo
	m_dwBufferInData--;
	memcpy( m_pbBuffer, m_pbBuffer+1, (size_t)m_dwBufferInData );

	return ( (int) cChar );
}

//
// Mobt@ɂf[^ׂĎM
//
BOOL CComm::ReadCommBlock()
{
	BOOL	fReadStat ;
	COMSTAT	ComStat ;
	DWORD	dwErrorFlags, dwLength ;
	BOOL	result;

	m_dwBufferInData = 0;

	if( m_fConnected == FALSE || g_signal == TRUE )				//ڑĂȂ΃G[
		return( FALSE );

	ClearCommError( m_idComDev, &dwErrorFlags, &ComStat );		//

	dwLength = min( (DWORD) RXQUEUE, ComStat.cbInQue );
	
	if (dwLength < 1)
	{
		if(WaitComm() == FALSE)									//Mf[^܂ő҂
			return( FALSE );
	}

	result = TRUE;
	fReadStat = ReadFile( m_idComDev, m_pbBuffer, dwLength, &dwLength, &m_osRead );
	if ( fReadStat == FALSE )
	{
		if( GetLastError() == ERROR_IO_PENDING )
		{
			if( GetOverlappedResult( m_idComDev, &m_osRead, &dwLength, TRUE ) == FALSE )
				result = FALSE;
		}
		else
		{
			result = FALSE;
		}
	}
	m_dwBufferInData = dwLength;
	ResetEvent(m_osRead.hEvent);
	return ( result );
}

//
// 1oCgo
//
BOOL CComm::WriteCommByte( BYTE bByte )
{
	BOOL	fWriteStat;
	DWORD	dwBytesWritten;
	BOOL	result;
	DWORD	dwError;
	COMSTAT	ComStat ;
	DWORD	dwErrorFlags;

	if( m_fConnected == FALSE || g_signal == TRUE )				//ڑĂȂ΃G[
		return( FALSE );

	result = TRUE;
	fWriteStat = WriteFile( m_idComDev, (LPSTR) &bByte, 1, &dwBytesWritten, &m_osWrite );
	if ( !fWriteStat )
	{
		dwError =  GetLastError();
		if( dwError == ERROR_IO_PENDING )
		{
			if( GetOverlappedResult( m_idComDev, &m_osRead, &dwBytesWritten, TRUE ) == FALSE )
				result = FALSE;
		}
		else
		{
			result = FALSE;
		}
	}
	ResetEvent(m_osWrite.hEvent);
	//obt@f[^ȂȂ܂ő҂
	do {
		if( g_signal == TRUE )
		{
			result = FALSE;
			break;
		}
		ClearCommError( m_idComDev, &dwErrorFlags, &ComStat );
	}while( ComStat.cbOutQue >  0 );
	return ( result );
}

//
//Mf[^҂
//
BOOL CComm::WaitComm()
{
	DWORD   dwEvtMask;
	BOOL	fRetVal;

	if ( m_dwBufferInData > 0 )
		return( TRUE );

	fRetVal = WaitCommEvent( m_idComDev, &dwEvtMask, NULL );
	if( dwEvtMask == 0 )
		return( FALSE );
	return ( fRetVal );
}


//
//VOinh[`
//
BOOL WINAPI CComm::handler_routine(DWORD dwCtrlType)
{
	g_signal = TRUE;
	SetCommMask( g_idComDev, 0 );								//WaitCommEvent̒f
	return( TRUE );
}
